// Copyright (C) 1996 T.Kamachi

import java.io.*;
import java.util.*;

public class MailFolder {
  private Hashtable ids = new Hashtable();
  File folder;

  public MailFolder(File dir) throws IOException {
    folder = dir;
    readFolder(dir);
  }

  private void readFolder(File dir) throws IOException {
    String files[] = dir.list();
    String id;
    String fname, mesNo;
    for (int i=0;i<files.length;i++) {
      if (files[i].startsWith("#")) {
        continue;
      }
      File f = new File(dir.toString() + File.separatorChar + files[i]);
      MailMessage m = new MailMessage(f);
      id = m.getField("Message-Id");
      fname = f.getName();
      int li = fname.lastIndexOf('.');
      if (li<0) {
        // for MH
        mesNo = fname;
      } else {
        // for Den8
        mesNo = fname.substring(0, li);
      }
      if (id!=null) {
        ids.put(id, mesNo);
      }
    }
  }

  public String getFolderName() {
    return folder.getName();
  }

  // this function should be overridden
  //  its better to use function object
  public void output(String id, String mesNo) {
  }

  public void process() {
    Enumeration keys = ids.keys();
    String id;
    while (keys.hasMoreElements()) {
      id = (String)keys.nextElement();
      output(id, (String)ids.get(id));
    }
  }
}
